// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hiroki SHIMORA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

#ifndef DEFAULT_FIELD_EVALUATOR_H
#define DEFAULT_FIELD_EVALUATOR_H

/////////////////////////////////////////////////////////////////////

#include "recursive_action_chain_graph.h"
#include <vector>

class DefaultFieldEvaluator : public rcsc::FieldEvaluator
{
private:
    static
    double
    get_chain_length_penalty( const std::vector< rcsc::ActionStatePair > & path,
                              const rcsc::PredictState & state );

public:
    DefaultFieldEvaluator();

    virtual
    ~DefaultFieldEvaluator();

    virtual
    double operator() ( const rcsc::PredictState & state,
                        const rcsc::WorldModel & wm,
                        const std::vector< rcsc::ActionStatePair > & path ) const;
public:
    static
    bool can_shoot_from( const rcsc::PredictState & wm,
                         const rcsc::Vector2D & pos,
                         const long valid_opponent_threshold );

    static
    double get_shoot_free_angle_from_pos( const rcsc::PredictState & wm,
                                          const long valid_opponent_threshold,
                                          const rcsc::Vector2D & pos );

    static
    double get_shoot_minimum_free_angle( const rcsc::PredictState & wm,
                                         const rcsc::Vector2D & goal,
                                         const long valid_opponent_threshold,
                                         const rcsc::Vector2D & pos );
    static
    bool is_free_situation_near_offside_line( const rcsc::PredictState & wm,
                                              const rcsc::AbstractPlayerObject * from );
};

#endif
