// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hiroki SHIMORA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

#ifndef RCSC_PLAYER_FIELD_EVALUATOR_H
#define RCSC_PLAYER_FIELD_EVALUATOR_H

/////////////////////////////////////////////////////////////////////

#include <rcsc/player/cooperative_action.h>
#include <rcsc/player/predict_state.h>
#include <rcsc/player/world_model.h>
#include <rcsc/player/action_state_pair.h>

#include <vector>
#include <boost/shared_ptr.hpp>

namespace rcsc {

/*!
  \class FieldEvaluator
  \brief abstract field evaluator function object class
*/
class FieldEvaluator {

protected:
    /*!
      \brief protected constructor to inhibit instantiation of this class
     */
    FieldEvaluator()
      { }

public:
    /*!
      \brief virtual destructor
     */
    virtual
    ~FieldEvaluator()
      { }

    /*!
      \brief evaluation function
      \param wm world model to evaluate
      \return evaluation value of world model
     */
    virtual
    double operator() ( const PredictState & state,
                        const rcsc::WorldModel & wm,
                        const std::vector< ActionStatePair > & path ) const = 0;
};

}

#endif
