// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 3, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////


#ifndef HELIOS_SIDE_FORWARD_H
#define HELIOS_SIDE_FORWARD_H

#include "soccer_role.h"

namespace rcsc {
class AngleDeg;
class Vector2D;
class PlayerAgent;
class Formation;
}

class RoleSideForward
    : public SoccerRole {
public:

    static const std::string NAME;

    RoleSideForward()
      { }

    ~RoleSideForward()
      {
          //std::cerr << "delete RoleSideForward" << std::endl;
      }

    virtual
    bool execute( rcsc::PlayerAgent * agent );

    static
    const
    std::string & name()
      {
          return NAME;
      }

    static
    SoccerRole::Ptr create()
      {
          SoccerRole::Ptr ptr( new RoleSideForward() );
          return ptr;
      }

private:
    void doKick( rcsc::PlayerAgent * agent );
    void doMove( rcsc::PlayerAgent * agent );


    //////////////////////////////////////////////////////
    void doDribbleAttackAreaKick( rcsc::PlayerAgent * agent );

    bool doStraightDribble( rcsc::PlayerAgent * agent );

    void doSideForwardDribble( rcsc::PlayerAgent * agent );
    rcsc::Vector2D getDribbleTarget( rcsc::PlayerAgent * agent );
    int getDribbleAttackDashStep( const rcsc::PlayerAgent * agent,
                                  const rcsc::AngleDeg & target_angle );

    void doMiddleAreaKick( rcsc::PlayerAgent * agent );
    void doCrossAreaKick( rcsc::PlayerAgent * agent );
    void doShootAreaKick( rcsc::PlayerAgent * agent );

    //////////////////////////////////////////////////////

    void doShootAreaMove( rcsc::PlayerAgent * agent );
    double getShootAreaMoveDashPower( rcsc::PlayerAgent * agent,
                                      const rcsc::Vector2D & target_point );
    rcsc::Vector2D getShootAreaMoveTarget( rcsc::PlayerAgent * agent,
                                           const rcsc::Vector2D & home_pos );
};


#endif
